require_relative 'lib/meshruby'
require 'pry'

uid   = "f6cffb60-da03-11e4-b0bb-ed16156c6fa4"
token = "7655d4abf306ca5cccbc79ee36f0fac02a230873"

mesh = EM::MeshRuby.new(uid, token)

mesh.toggle_debug!

# http get https://meshblu.octoblu.com/data/f6cffb60-da03-11e4-b0bb-ed16156c6fa4 meshblu_auth_uuid:f6cffb60-da03-11e4-b0bb-ed16156c6fa4 meshblu_auth_token:7655d4abf306ca5cccbc79ee36f0fac02a230873
class KeyboardHandler < EM::Connection
  include EM::Protocols::LineText2

  attr_reader :mesh

  def initialize(mesh)
    @mesh = mesh
  end

  def receive_line(data)
    puts (mesh.instance_eval(data) || "OK")
    print "> "
  rescue Exception => exc
    exit(0) if data.start_with?('q')
    puts "#{exc.message}"
    print "> "
  end
end

EM.run do
  mesh.connect
  mesh.onmessage do |msg|
    begin
      mesh.emit(msg["fromUuid"], {wow: "Thanks! :)"})
    rescue => e
      binding.pry
    end
  end
  puts "Ready."
  print "> "
  EM.open_keyboard(KeyboardHandler, mesh)
end
